﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private Button1 As Button
	Private Button2 As Button
	Private Button3 As Button
	Private Button4 As Button
	Private Button5 As Button
	Private Button6 As Button
	Private Pane1 As Panel
	Public cnvs As B4XCanvas
	Public buttonsmap As Map
	Public propsmap As Map
	Public btnsource As Button
	Public btndest As Button
	Public oldx As Float
	Public oldy As Float
	Public startx As Double
	Public starty As Double
	Public endx	As Double
	Public endy As Double
	Public finishdraw As Boolean
	Public mousedragged As Boolean
	Public direction As String
	Public linecollectionmap As Map
	Public linemap As Map
	Public keycnt As Int = 0
	Public buttonsactivated As Boolean
	Private cbxlinecount As B4XComboBox
	Public maxcnt As Int
	Private lblmessage As Label
	Private msg As String
	Private sourceselected As Boolean
	Private pnloverlay As Panel
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"Connect the buttons")
	cnvs.Initialize(pnloverlay)
	buttonsmap.Initialize
	propsmap.Initialize
	btnsource.Initialize("")
	btndest.Initialize("")
	For Each vw As B4XView In Pane1.GetAllViewsRecursive
		If vw Is Button Then
			propsmap = CreateMap("left":vw.Left,"top":vw.Top,"width":vw.Width,"height":vw.Height)
			buttonsmap.Put(vw.tag,propsmap)
		End If
	Next
	linecollectionmap.Initialize
	linemap.Initialize
	disable_buttons
	Dim lst As List = Array As Int(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15)
	cbxlinecount.SetItems(lst)
	sourceselected = False
	msg = lblmessage.Text
	lblmessage.Text = msg & "(" & keycnt & ")"
End Sub
Private Sub disable_buttons
	For Each vw As B4XView In Pane1.GetAllViewsRecursive
		If vw Is Button Then
			vw.Enabled = False
		End If
	Next
	buttonsactivated = False
End Sub
Private Sub enable_buttons
	For Each vw As B4XView In Pane1.GetAllViewsRecursive
		If vw Is Button Then
			vw.Enabled = True
		End If
	Next
	buttonsactivated = True
End Sub
Private Sub remove_borders
	For Each vw As B4XView In Pane1.GetAllViewsRecursive
		If vw Is Button Then
			vw.SetColorAndBorder(xui.Color_LightGray,0,xui.Color_Transparent,0)
		End If
	Next
End Sub
Private Sub Pane1_LongClick
	reset_canvas
	finishdraw = False
	mousedragged = False
	disable_buttons
	remove_borders
	btnsource.Initialize("")
	btndest.Initialize("")
	startx = 0
	starty = 0
	endx = 0
	endy = 0
	keycnt = 0
	linecollectionmap.Clear
	linemap.Clear	
	pnloverlay.BringToFront
End Sub
Private Sub pnloverlay_Touch (Action As Int, X As Float, Y As Float)
	Log("action: " & Action)
	Log("x: " & X)
	Log("y: " & Y)
	If Action = 0 Then						' down
		If finishdraw = True Then Return
		If buttonsactivated = True Then Return
		Log("Action down = " & Action)
		oldx = X
		oldy = Y
		Dim xpos As Float = X
		Dim ypos As Float = Y
		For Each key In buttonsmap.Keys
			propsmap = buttonsmap.Get(key)
			Dim left As Double = propsmap.Get("left")
			Dim top As Double = propsmap.Get("top")
			Dim width As Double = propsmap.Get("width")
			Dim height As Double = propsmap.Get("height")
			If xpos >= left And ypos >= top And xpos <= left+width And ypos <= top+height Then
				Dim name As String = key.As(String)
				Dim index As Int = name.SubString(name.Length-1)	' last character is button counter
				btnsource = Pane1.GetView(index-1)					' node 0 is the canvas!
				btnsource.SetColorAnimated(0,xui.Color_LightGray,xui.Color_Yellow)
				startx = xpos
				starty = ypos
				disable_buttons
				sourceselected = True
			End If
		Next
		If sourceselected = False Then
			reset_canvas
			mousedragged = False
			finishdraw = False
			startx = 0
			starty = 0
			endx = 0
			endy = 0
		End If
	End If
	If Action = 1 Then						' up
		Log("Action = " & Action)
		reset_canvas
		If startx > 0 And starty > 0 And endx > 0 And endy > 0 And finishdraw = True Then
			If btnsource.IsInitialized = True And btndest.IsInitialized = True Then
				set_startpos_and_endpos
				Select direction
					Case "upperright"
						startx = btnsource.Left+btnsource.Width
						starty = btnsource.Top
						endx = btndest.left
						endy = btndest.Top+btndest.height
					Case "middleright"
						startx = btnsource.Left+btnsource.Width
						starty = btnsource.Top+(btnsource.Height/2)
						endx = btndest.left
						endy = btndest.Top+(btndest.height/2)
					Case "lowerright"
						startx = btnsource.Left+btnsource.Width
						starty = btnsource.Top+btnsource.Height
						endx = btndest.left
						endy = btndest.Top
					Case "upperleft"
						startx = btnsource.Left
						starty = btnsource.Top
						endx = btndest.left+btndest.Width
						endy = btndest.Top+btndest.height
					Case "middleleft"
						startx = btnsource.Left
						starty = btnsource.Top+(btnsource.Height/2)
						endx = btndest.left+btndest.Width
						endy = btndest.Top+(btndest.height/2)
					Case "lowerleft"
						startx = btnsource.Left
						starty = btnsource.Top+btnsource.Height
						endx = btndest.left+btndest.width
						endy = btndest.Top
					Case "up"
						startx = btnsource.Left+(btnsource.Width/2)
						starty = btnsource.Top
						endx = btndest.left+(btndest.Width/2)
						endy = btndest.Top+btndest.height
					Case "down"
						startx = btnsource.Left+(btnsource.Width/2)
						starty = btnsource.Top+btnsource.Height
						endx = btndest.left+(btndest.Width/2)
						endy = btndest.Top
				End Select
				linemap = CreateMap("startx":startx,"starty":starty,"endx":endx,"endy":endy, _
								"color":xui.Color_Red,"strokewidth":5)
				linecollectionmap.Put(keycnt,linemap)
				keycnt = keycnt + 1
				draw_lines
				lblmessage.Text = msg & "(" & keycnt & ")"
			End If
		End If
		finishdraw = True
		mousedragged = False
		If keycnt > cbxlinecount.SelectedItem -1 Then
			enable_buttons
			pnloverlay.SendToBack
		Else
			finishdraw = False
		End If
	End If
	If Action=2 Then						' move
		Log("Action = " & Action)
		xpos = X
		ypos = Y
		cnvs.DrawLine(oldx,oldy,xpos,ypos,xui.Color_Blue,5)
		cnvs.Invalidate
		oldx = X
		oldy = Y
		If btnsource.IsInitialized = True And sourceselected = True Then
			For Each key In buttonsmap.Keys
				propsmap = buttonsmap.Get(key)
				Dim left As Double = propsmap.Get("left")
				Dim top As Double = propsmap.Get("top")
				Dim width As Double = propsmap.Get("width")
				Dim height As Double = propsmap.Get("height")
				If xpos >= left And ypos >= top And xpos <= left+width And ypos <= top+height Then
					Dim name As String = key.As(String)
					Dim index As Int = name.SubString(name.Length-1)
					btndest = Pane1.GetView(index-1)
					If btnsource.Tag <> btndest.Tag Then
						btnsource.SetColorAnimated(0,xui.Color_LightGray,xui.Color_Green)
						btndest.SetColorAnimated(0,xui.Color_LightGray,xui.Color_Cyan)
						finishdraw = True
						mousedragged = True
						endx = xpos
						endy = ypos
						sourceselected = False
						Return
					End If
				End If
			Next
		End If
	End If
End Sub
Private Sub draw_lines
	For Each key In linecollectionmap.Keys
		Dim lmap As Map = linecollectionmap.Get(key)
		cnvs.DrawLine(lmap.Get("startx"),lmap.Get("starty"),lmap.Get("endx"),lmap.Get("endy"), _
					  lmap.Get("color"),lmap.Get("strokewidth"))
	Next
	cnvs.Invalidate
End Sub
Private Sub set_startpos_and_endpos
	' from the center of the buttons
	startx = btnsource.Left+(btnsource.Width/2)
	starty = btnsource.top+(btnsource.height/2)
	endx = btndest.Left+(btndest.Width/2)
	endy = btndest.top+(btndest.height/2)
	Log(startx & " " & starty & " " & endx & " " & endy)
	direction = ""
	Dim rect As B4XRect		' surrounding rectangle to determine the direction of the line
	Dim left As Int
	Dim top As Int
	Dim right As Int
	Dim bottom As Int
	If startx > endx Then
		left = endx
		right = startx
	Else
		left = startx
		right = endx
	End If
	If starty > endy Then
		top = endy
		bottom = starty
	Else
		top = starty
		bottom = endy
	End If
	rect.Initialize(left,top,right,bottom)
	Log("rect width: " & rect.Width)
	Log("rect height: " & rect.Height)
	If rect.Width > 70 Then
		If startx > endx Then	' left
			If rect.Height > 50 Then
				If starty > endy Then
					direction = "upperleft"
				Else
					direction = "lowerleft"
				End If
			Else
				direction = "middleleft"
			End If
		Else					' right
			If rect.Height > 50 Then
				If starty > endy Then
					direction = "upperright"
				Else
					direction = "lowerright"
				End If
			Else
				direction = "middleright"
			End If
		End If
	Else								' a narrow width means up or down
		If starty > endy Then	' up
			direction = "up"
		Else					'down
			direction = "down"	
		End If
	End If
	Log(direction)
End Sub
Private Sub reset_canvas
	Dim rect As B4XRect
	rect.Initialize(0,0,pnloverlay.Width+pnloverlay.Left,pnloverlay.Height+pnloverlay.Top)
	cnvs.ClearRect(rect)
	cnvs.Invalidate
End Sub
Private Sub Button1_Click
	xui.MsgboxAsync("button 1 clicked", "Button1")
End Sub
Private Sub Button2_Click
	xui.MsgboxAsync("button 2 clicked", "Button2")	
End Sub
Private Sub Button3_Click
	xui.MsgboxAsync("button 3 clicked", "Button3")	
End Sub
Private Sub Button4_Click
	xui.MsgboxAsync("button 4 clicked", "Button4")	
End Sub
Private Sub Button5_Click
	xui.MsgboxAsync("button 5 clicked", "Button5")	
End Sub
Private Sub Button6_Click
	xui.MsgboxAsync("button 6 clicked", "Button6")
End Sub
Private Sub cbxlinecount_SelectedIndexChanged (Index As Int)
	maxcnt = cbxlinecount.SelectedItem
End Sub
